Imports System.Globalization
Imports System.ComponentModel
Imports System.Resources
Imports System.Threading

Public Class Form1
    ' Select English.
    Private Sub radEnglish_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radEnglish.CheckedChanged
        Dim frm As Form1 = LocalizedForm("en-US", radEnglish, radGerman)
        If frm Is Nothing Then Exit Sub
        frm.radEnglish.Checked = True

        frm.Show()
        Me.Close()
    End Sub

    ' Select German.
    Private Sub radGerman_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radGerman.CheckedChanged
        Dim frm As Form1 = LocalizedForm("de-DE", radGerman, radEnglish)
        If frm Is Nothing Then Exit Sub
        frm.radGerman.Checked = True

        frm.Show()
        Me.Close()
    End Sub

    ' Reload the form using this locale.
    Private Function LocalizedForm(ByVal locale_name As String, ByVal checked_button As RadioButton, ByVal unchecked_button As RadioButton) As Form1
        If Not Me.Created Then Return Nothing
        If Not checked_button.Checked Then Return Nothing

        ' Make a CultureInfo.
        Dim culture_info As New CultureInfo(locale_name)

        ' Make the thread use this locale.
        Thread.CurrentThread.CurrentUICulture = culture_info
        Thread.CurrentThread.CurrentCulture = culture_info

        Dim frm As New Form1
        frm.radGerman.Checked = False
        frm.radEnglish.Checked = True
        frm.Location = Me.Location
        Return frm
    End Function

    ' Display Help About.
    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click
#If True Then
        ' The easy way
        MessageBox.Show(My.Resources.RuntimeStrings.Help_About)
#Else
        ' This vesion explicitly uses a ResourceManager.
        ' The base name is <ProjectName>.<FileName>.
        Dim resource_manager As New ResourceManager("Localized.RuntimeStrings", Me.GetType.Assembly)

        ' Display the message.
        MessageBox.Show(resource_manager.GetString("Help_About"))
#End If
    End Sub

    ' Exit.
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub
End Class
